/* $Source: /users/programmers/mdh/src/mdf/RCS/mdf.c,v $
 * mdf   Mike's Disk Free
 *
 * Coherent 4.0 mdf,   Michael Hughes, Festus MO 63028
 *
 *  This program reads /etc/mnttab file and display the amount of total, used
 * and available. The program displays the information in a Berkeley style.
 *
 *  This program is copyright by Michael Hughes.  It can be used as is as long 
 * as this message and the RCSid is in the code.  If you make any changes to the
 * program or find any bugs, please let me know.  You can send me mail at:
 *                       mwcbbs!loghome!mdh
 *
 * Modification History:
 * $Log:	mdf.c,v $
 * Revision 1.3  92/11/28  18:27:11  mdh
 * change to add .05 to the % and print 1 dec .
 * 
 * Revision 1.2  92/09/17  18:12:46  mdh
 * Added error checking on the open of the file.
 * 
 * Revision 1.1  92/09/12  18:55:50  mdh
 * Initial revision
 *  */

#include <stdio.h>
#include <sys/types.h>
#include <sys/statfs.h>
#include <mnttab.h>
#include <errno.h>
#include <time.h>
#include <fcntl.h>

char	RCSid[] = "$Header: /users/programmers/mdh/src/mdf/RCS/mdf.c,v 1.3 92/11/28 18:27:11 mdh Exp Locker: mdh $";

struct	statfs buffer, *ptr_buffer;
struct	mnttab mounted, *ptr_mounted;

int 	buffer_length,fstype;
int 	mnttab_length, mnttab_fd;
int 	bytes_read, x;
int	blocks_on_disk, blocks_free, kbytes_on_disk, kbytes_free, kbytes_used; 
float	per;

char heading[] = "Filesystem         kbytes      used     avail capacity Mounted on";

main(argc, argv)
int	argc;
char	*argv[];

{
   ptr_buffer=&buffer;
   ptr_mounted=&mounted;

   buffer_length = sizeof(struct statfs);
   mnttab_length = sizeof(struct mnttab);

   fstype = 0;

   if ((mnttab_fd = open("/etc/mnttab",O_RDONLY)) == -1) 	/* open file to get mounted vol */
   {
   	fprintf(stderr,"%s:Can not open /etc/mnttab\n",argv[0]);
   	exit(-1);
   	}

   fprintf(stdout,"%s\n",heading);
	
   while (read(mnttab_fd,ptr_mounted,mnttab_length))	/* read from file till end */
       {	
           if (ptr_mounted->mt_filsys[0] != '\000')	/* skip it if no longer mounted */
           {
               x = statfs(ptr_mounted->mt_dev, ptr_buffer, buffer_length, fstype);	/* get info */
               blocks_on_disk = ptr_buffer->f_blocks;
               blocks_free = ptr_buffer->f_bfree;
               kbytes_on_disk = (ptr_buffer->f_blocks * ptr_buffer->f_bsize) / 1024;
               kbytes_free = (ptr_buffer->f_bfree * ptr_buffer->f_bsize) / 1024;
               kbytes_used = kbytes_on_disk - kbytes_free;
               per = ((kbytes_free * 1.0) / (kbytes_on_disk * 1.0) * 100) + .05;

               fprintf(stdout,"/dev/%-10s %9d %9d %9d   %3.1f%%   %s\n",
						ptr_mounted->mt_filsys,
						kbytes_on_disk,
						kbytes_used,
						kbytes_free,
						per,
						ptr_mounted->mt_dev);
             fprintf(stdout,"%s\n",ctime(&ptr_mounted->mt_time));  
	       }
          }	
    }
